<template>
  <div>
    <div class="card card-custom" style="margin-bottom: 3rem">
      <div class="card-body">
        <div class="row">
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Nickname"
              label-for="input-lg"
            >
              <b-form-select
                id="input-lg"
                value-field="nickname"
                text-field="nickname"
                size="lg"
                v-model="selectNickname"
              >
                <b-form-select-option
                  v-for="(proj, i) in this.$store.getters.getterProject"
                  v-bind:key="i"
                  :value="proj.code"
                >
                  {{ proj.nickname }}
                </b-form-select-option>
              </b-form-select>
            </b-form-group>
          </div>
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Owner"
              label-for="input-lg"
            >
              <b-form-input
                id="input-lg"
                size="lg"
                v-model="selectedNickname.ownerProject"
                disabled
              ></b-form-input>
            </b-form-group>
          </div>
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Nama Proyek"
              label-for="input-lg"
            >
              <b-form-input
                id="input-lg"
                size="lg"
                v-model="selectedNickname.nameProject"
                disabled
              ></b-form-input>
            </b-form-group>
          </div>
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Nomor Kontrak"
              label-for="input-lg"
            >
              <b-form-input
                id="input-lg"
                size="lg"
                v-model="selectedNickname.noProject"
                disabled
              ></b-form-input>
            </b-form-group>
          </div>
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Status"
              label-for="input-lg"
            >
              <b-form-input
                id="input-lg"
                size="lg"
                v-model="selectedNickname.statusProject"
                disabled
              ></b-form-input>
            </b-form-group>
          </div>
        </div>
      </div>
    </div>

    <div class="card" style="margin-bottom: 3rem">
      <div class="card-body">
        <div class="row">
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Stasiun"
              label-for="input-lg"
            >
              <b-form-select
                id="input-lg"
                size="lg"
                v-model="search.searchStation"
              >
                <b-form-select-option
                  v-for="(stat, i) in this.$store.getters.getterStation
                    .stations"
                  v-bind:key="i"
                  :value="stat.code"
                >
                  {{ stat.name }}
                </b-form-select-option>
              </b-form-select>
            </b-form-group>
          </div>
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Scope"
              label-for="input-lg"
            >
              <b-form-select
                id="input-lg"
                size="lg"
                v-model="search.searchScope"
              >
                <b-form-select-option
                  v-for="(scp, i) in this.$store.getters.getterScope"
                  v-bind:key="i"
                  :value="scp.code"
                >
                  {{ scp.name }}
                </b-form-select-option>
              </b-form-select>
            </b-form-group>
          </div>
          <div class="col-md-6 col-sm-12">
            <b-form-group
              label-cols="4"
              label-cols-lg="3"
              label-size="lg"
              label="Title"
              label-for="input-lg"
            >
              <b-form-input
                id="input-lg"
                size="lg"
                class="title_search"
                v-model="search.searchTitle"
              ></b-form-input>
            </b-form-group>
          </div>
        </div>
        <div class="row">
          <div class="col-12 d-flex justify-content-end">
            <p>{{ search.searchDesign }}</p>

            <div class="button-group">
              <button
                class="btn btn-primary mr-2"
                @click.prevent="doSearch"
                v-bind:class="{
                  disabled: disabledSearch
                }"
              >
                <div
                  v-bind:class="{
                    'd-none': loaderSearch
                  }"
                >
                  <div class="text-center">
                    <b-spinner
                      variant="secondary"
                      label="Spinning"
                      style="width: 1rem; height: 1rem;"
                    ></b-spinner>
                  </div>
                </div>

                <i v-if="loaderReset" class="flaticon2-search-1"></i>
                {{ searchButtonText }}
              </button>

              <button
                class="btn btn-secondary"
                @click.prevent="resetTable"
                v-bind:class="{
                  disabled: disabledReset
                }"
              >
                <div
                  v-bind:class="{
                    'd-none': loaderReset
                  }"
                >
                  <div class="text-center">
                    <b-spinner
                      variant="secondary"
                      label="Spinning"
                      style="width: 1rem; height: 1rem;"
                    ></b-spinner>
                  </div>
                </div>
                <i v-if="loaderReset" class="flaticon2-time"></i>{{ resetText }}
              </button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="card card-custom p-5 gutter-b">
      <div class="card-body p-0">
        <b-tabs v-model="tabIndex">
          <!-- document tab -->
          <b-tab title="Document" active>
            <div class="card border-0" style="margin-bottom: 3rem">
              <div class="card-body">
                <div class="button-group d-flex justify-content-end mb-4">
                  <button
                    class="btn btn-primary"
                    v-if="this.selectNickname == null"
                    disabled
                  >
                    Load design
                  </button>
                  <button
                    class="btn btn-primary"
                    @click.prevent="loadDesign('DOC')"
                    v-else
                  >
                    Load design
                  </button>
                </div>

                <complete-table
                  :data="this.$store.getters.getterDesign.designs"
                  :loading="false"
                >
                  <template #header>
                    <tr>
                      <th></th>
                      <th>Numbering</th>
                      <th>Title</th>
                      <th>Type</th>
                      <th>Category</th>
                      <th>Scope</th>
                      <th>Stasiun</th>
                      <th>Hapus design</th>
                    </tr>
                  </template>

                  <template #defaultBody="{item: data, i}">
                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': tableBody
                      }"
                    >
                      <td v-if="data.added == 0">
                        <label class="form-checkbox">
                          <input
                            type="checkbox"
                            :value="
                              data.design_code +
                                '/' +
                                data.numbering +
                                '/' +
                                data.title +
                                '/' +
                                data.type.code +
                                '/' +
                                data.station +
                                '/' +
                                data.station
                            "
                            v-model="selectedDesign"
                          />
                        </label>
                      </td>
                      <td v-else></td>
                      <td>{{ data.numbering }}</td>
                      <td>{{ data.title }}</td>
                      <td>{{ data.type.code }}</td>
                      <td v-if="data.scope.scope_category_code == null">-</td>
                      <td v-else>{{ data.scope.scope_category_code }}</td>
                      <td>{{ data.scope_code }}</td>
                      <td>
                        <template>
                          <div v-if="data.station == null">
                            -
                          </div>
                          <div v-else>
                            {{ data.station.name }}
                          </div>
                        </template>
                      </td>
                      <td v-if="data.added == 1">
                        <label class="form-checkbox">
                          <input
                            type="checkbox"
                            :value="data.id"
                            v-model="selectedDeleteDesign"
                          />
                        </label>
                      </td>
                      <td v-else></td>
                    </tr>
                  </template>
                </complete-table>

                <!-- button save -->
                <div
                  v-bind:class="{
                    'd-none': actionDesign
                  }"
                >
                  <div class="button-group d-flex justify-content-end">
                    <button class="btn btn-success" @click.prevent="saveDesign">
                      <div
                        v-bind:class="{
                          'd-none': loaderSaveDesign
                        }"
                      >
                        <div class="text-center">
                          <b-spinner
                            variant="secondary"
                            label="Spinning"
                            style="width: 1rem; height: 1rem;"
                          ></b-spinner>
                        </div>
                      </div>
                      {{ loaderSaveDesignText }}
                    </button>

                    <button
                      class="btn btn-danger ml-2"
                      @click.prevent="deleteDesign"
                    >
                      <div
                        class="loader"
                        v-bind:class="{
                          'd-none': loaderDeleteDesign
                        }"
                      >
                        <div class="text-center">
                          <b-spinner
                            variant="secondary"
                            label="Spinning"
                            style="width: 1rem; height: 1rem;"
                          ></b-spinner>
                        </div>
                      </div>
                      {{ loaderDeleteDesignText }}
                    </button>
                  </div>
                </div>
                <!-- end button save -->
              </div>
            </div>
          </b-tab>
          <!-- end document tab -->

          <!-- drawing tab -->
          <b-tab title="Drawing">
            <div class="card border-0" style="margin-bottom: 3rem">
              <div class="card-body">
                <div class="button-group d-flex justify-content-end mb-4">
                  <button
                    class="btn btn-primary"
                    @click.prevent="loadDesign('DRW')"
                  >
                    Load design
                  </button>
                </div>

                <complete-table
                  :loading="false"
                  :data="this.$store.getters.getterDesign.designs"
                >
                  <template #header>
                    <tr>
                      <th></th>
                      <th>Numbering</th>
                      <th>Title</th>
                      <th>Type</th>
                      <th>Category</th>
                      <th>Scope</th>
                      <th>Stasiun</th>
                      <th>Hapus design</th>
                    </tr>
                  </template>

                  <template #defaultBody="{item: data, i}">
                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': tableBody
                      }"
                    >
                      <td v-if="data.added == 0">
                        <label class="form-checkbox">
                          <input
                            type="checkbox"
                            :value="
                              data.design_code +
                                '/' +
                                data.numbering +
                                '/' +
                                data.title +
                                '/' +
                                data.type.code +
                                '/' +
                                data.station +
                                '/' +
                                data.station
                            "
                            v-model="selectedDesign"
                          />
                        </label>
                      </td>
                      <td v-else></td>
                      <td>{{ data.numbering }}</td>
                      <td>{{ data.title }}</td>
                      <td>{{ data.type.code }}</td>
                      <td v-if="data.scope.scope_category_code == null">-</td>
                      <td v-else>{{ data.scope.scope_category_code }}</td>
                      <td>{{ data.scope_code }}</td>
                      <td>
                        <template>
                          <div v-if="data.station == null">
                            -
                          </div>
                          <div v-else>
                            {{ data.station.name }}
                          </div>
                        </template>
                      </td>
                      <td v-if="data.added == 1">
                        <label class="form-checkbox">
                          <input
                            type="checkbox"
                            :value="
                              data.design_code +
                                '/' +
                                data.numbering +
                                '/' +
                                data.title +
                                '/' +
                                data.type.code +
                                '/' +
                                data.station +
                                '/' +
                                data.station
                            "
                            v-model="selectedDeleteDesign"
                          />
                        </label>
                      </td>
                      <td v-else></td>
                    </tr>
                  </template>
                </complete-table>

                <!-- button save -->
                <div
                  v-bind:class="{
                    'd-none': actionDesign
                  }"
                >
                  <div class="button-group d-flex justify-content-end d-none">
                    <button class="btn btn-success" @click.prevent="saveDesign">
                      <div
                        class="loader"
                        v-bind:class="{
                          'd-none': loaderSaveDesign
                        }"
                      >
                        <div class="text-center">
                          <b-spinner
                            variant="secondary"
                            label="Spinning"
                            style="width: 1rem; height: 1rem;"
                          ></b-spinner>
                        </div>
                      </div>
                      {{ loaderSaveDesignText }}
                    </button>

                    <button class="ml-2 btn btn-danger">Hapus</button>
                  </div>
                </div>
                <!-- end button save -->
              </div>
            </div>
          </b-tab>
          <!-- end drawing tab -->

          <!-- form tab -->
          <b-tab title="Form">
            <div class="card border-0" style="margin-bottom: 3rem">
              <div class="card-body">
                <div class="button-group d-flex justify-content-end mb-4">
                  <button
                    class="btn btn-primary"
                    @click.prevent="loadDesign('FOR')"
                  >
                    Load design
                  </button>
                </div>

                <complete-table
                  :loading="false"
                  :data="this.$store.getters.getterDesign.designs"
                >
                  <template #header>
                    <tr>
                      <th></th>
                      <th>Numbering</th>
                      <th>Title</th>
                      <th>Type</th>
                      <th>Category</th>
                      <th>Scope</th>
                      <th>Stasiun</th>
                      <th>Hapus design</th>
                    </tr>
                  </template>

                  <template #defaultBody="{item: data, i}">
                    <tr
                      v-bind:key="i"
                      v-bind:class="{
                        'd-none': tableBody
                      }"
                    >
                      <td v-if="data.added == 0">
                        <label class="form-checkbox">
                          <input
                            type="checkbox"
                            :value="
                              data.design_code +
                                '/' +
                                data.numbering +
                                '/' +
                                data.title +
                                '/' +
                                data.type.code +
                                '/' +
                                data.station +
                                '/' +
                                data.station
                            "
                            v-model="selectedDesign"
                          />
                        </label>
                      </td>
                      <td v-else></td>
                      <td>{{ data.numbering }}</td>
                      <td>{{ data.title }}</td>
                      <td>{{ data.type.code }}</td>
                      <td v-if="data.scope.scope_category_code == null">-</td>
                      <td v-else>{{ data.scope.scope_category_code }}</td>
                      <td>{{ data.scope_code }}</td>
                      <td>
                        <template>
                          <div v-if="data.station == null">
                            -
                          </div>
                          <div v-else>
                            {{ data.station.name }}
                          </div>
                        </template>
                      </td>
                      <td v-if="data.added == 1">
                        <label class="form-checkbox">
                          <input
                            type="checkbox"
                            :value="
                              data.design_code +
                                '/' +
                                data.numbering +
                                '/' +
                                data.title +
                                '/' +
                                data.type.code +
                                '/' +
                                data.station +
                                '/' +
                                data.station
                            "
                            v-model="selectedDeleteDesign"
                          />
                        </label>
                      </td>
                      <td v-else></td>
                    </tr>
                  </template>
                </complete-table>

                <!-- button save -->
                <div
                  v-bind:class="{
                    'd-none': actionDesign
                  }"
                >
                  <div class="button-group d-flex justify-content-end d-none">
                    <button class="btn btn-success" @click.prevent="saveDesign">
                      <div
                        class="loader"
                        v-bind:class="{
                          'd-none': loaderSaveDesign
                        }"
                      >
                        <div class="text-center">
                          <b-spinner
                            variant="secondary"
                            label="Spinning"
                            style="width: 1rem; height: 1rem;"
                          ></b-spinner>
                        </div>
                      </div>
                      {{ loaderSaveDesignText }}
                    </button>

                    <button class="ml-2 btn btn-danger">Hapus</button>
                  </div>
                </div>
                <!-- end button save -->
              </div>
            </div>
          </b-tab>
          <!-- end form tab -->
        </b-tabs>
      </div>
    </div>
  </div>
</template>

<script>
import { SHOW_PROJECT } from "@/core/services/store/dl.design.module.js";
import { GET_STATION } from "@/core/services/store/dl.design.module.js";
import { GET_SCOPE } from "@/core/services/store/dl.design.module.js";
import { GET_DESIGN } from "@/core/services/store/dl.design.module.js";
import { SEARCH_DESIGN } from "@/core/services/store/dl.design.module.js";
import { SAVE_DESIGN } from "@/core/services/store/dl.design.module.js";
import { CURRENT_DESIGN_CODE } from "@/core/services/store/dl.design.module.js";
import Vue from "vue";
import axios from "axios";
import VueAxios from "vue-axios";
import { SET_BREADCRUMB } from "../../../core/services/store/breadcrumbs.module";
import CompleteTable from "../../content/widgets/advance-table/CompleteTable";
Vue.use(VueAxios, axios);

export default {
  name: "design",
  components: { CompleteTable },
  data() {
    return {
      form: {
        owner: "",
        name: "",
        nickname: "",
        food: null,
        checked: ["not_accepted"]
      },
      selectedNickname: {
        ownerProject: null,
        nameProject: null,
        noProject: null,
        statusProject: null
      },
      search: [
        {
          searchStation: "",
          searchScope: "",
          searchTitle: ""
        }
      ],
      selectNickname: null,
      selectedDesign: [],
      loaderSaveDesignText: "Simpan",
      loaderSaveDesign: true,
      loaderDeleteDesignText: "Hapus",
      loaderDeleteDesign: true,
      actionDesign: true,
      tableDesignLoader: true,
      selectedDeleteDesign: [],
      tabIndex: 1,
      tableBody: false,
      disabledSearch: true,
      disabledReset: true,
      searchButtonText: "Filter",
      loaderSearch: true,
      loaderReset: true,
      emptyTable: false,
      resetText: "Reset",
      show: true
    };
  },
  methods: {
    onSubmit(event) {
      event.preventDefault();
      alert(JSON.stringify(this.form));
    },
    onReset(event) {
      event.preventDefault();
      // Reset our form values
      this.form.email = "";
      this.form.name = "";
      this.form.food = null;
      this.form.checked = [];
      // Trick to reset/clear native browser form validation state
      this.show = false;
      this.$nextTick(() => {
        this.show = true;
      });
    },
    async loadDesign(params) {
      this.actionDesign = true;
      this.tableDesignLoader = false;
      this.emptyTable = true;
      this.tableBody = true;
      var currentCode = this.$store.getters.getterCurrentCode;
      await this.$store.dispatch(GET_DESIGN, {
        type: params,
        code: currentCode
      });
      this.tableBody = false;
      this.disabledSearch = false;
      this.disabledReset = false;
      this.tableBody = false;
      this.tableDesignLoader = true;
      this.actionDesign = false;
    },
    async doSearch() {
      var station = this.search.searchStation;
      var scope = this.search.searchScope;
      var title = this.search.searchTitle;
      var newTitle;
      console.log(title);
      if (title != undefined) {
        newTitle = title.toLowerCase();
      } else {
        newTitle = undefined;
      }
      console.log(newTitle);
      var newArr = this.$store.getters.getterMasterDesign.designs.filter(
        res =>
          res.station.code.includes(station) ||
          res.scope.code.includes(scope) ||
          res.title.toLowerCase().includes(newTitle)
      );
      console.log(newArr);
      var type = this.$store.getters.getterMasterDesign.type;
      var result = {
        designs: newArr,
        type: type
      };

      if (newArr.length > 0) {
        this.searchButtonText = "";
        this.loaderSearch = false;
        await this.$store.dispatch(SEARCH_DESIGN, result);
        this.searchButtonText = "Cari";
        this.loaderSearch = true;
      } else {
        var typeDoc = this.$store.getters.getterTypeDesign;
        this.loadDesign(typeDoc);
      }
    },
    async resetTable() {
      var type = this.$store.getters.getterTypeDesign;
      this.loaderReset = false;
      this.resetText = "";
      await this.loadDesign(type);
      this.loaderReset = true;
      this.resetText = "Reset";
      this.search.searchStation = undefined;
      this.search.searchScope = undefined;
      this.search.searchTitle = undefined;
    },

    async saveDesign() {
      var valueInput = this.selectedDesign;
      var sp = [];
      for (var o = 0; o < valueInput.length; o++) {
        sp[o] = valueInput[o].split("/");
      }

      var send = [];
      for (var i = 0; i < sp.length; i++) {
        send[i] = {
          project: {
            code: this.$store.getters.getterProject[0].code
          },
          design: {
            code: sp[i][0]
          },
          numbering: sp[i][1],
          title: sp[i][2],
          type: {
            code: sp[i][3]
          },
          station: {
            code: sp[i][4],
            name: sp[i][5]
          }
        };
      }

      var obj = {
        design: send
      };

      this.loaderSaveDesignText = "";
      this.loaderSaveDesign = false;
      await this.$store.dispatch(SAVE_DESIGN, obj);
      this.selectedDesign = [];
      this.loaderSaveDesignText = "Simpan";
      this.loaderSaveDesign = true;
      var typeDoc = this.$store.getters.getterTypeDesign;
      this.loadDesign(typeDoc);
    },

    deleteDesign() {
      var id = this.selectedDeleteDesign;
      console.log(id);
    }
  },
  async mounted() {
    await this.$store.dispatch(SHOW_PROJECT);

    this.$store.dispatch(SET_BREADCRUMB, [{ title: "DL Design Drafting" }]);
  },

  computed: {
    currentNick() {
      return this.selectNickname;
    },

    currentTab() {
      return this.tabIndex;
    }
  },
  watch: {
    currentNick(nick) {
      Object.assign(this.selectedNickname, {
        ownerProject: this.$store.getters.getterProject[0].owner,
        nameProject: this.$store.getters.getterProject[0].name,
        noProject: this.$store.getters.getterProject[0].contract_no,
        statusProject: this.$store.getters.getterProject[0].status
      });

      this.$store.dispatch(CURRENT_DESIGN_CODE, { code: nick });
      this.$store.dispatch(GET_STATION, { id: nick });
      this.$store.dispatch(GET_SCOPE);
    },

    currentTab(v) {
      if (v == 0) {
        this.tableBody = true;
        this.actionDesign = true;
        this.disabledSearch = true;
        this.disabledReset = true;
      } else {
        this.disabledSearch = true;
        this.disabledReset = true;
        this.actionDesign = true;
        this.tableBody = true;
      }
    }
  }
};
</script>
